package info.frostfs.sdk;

import info.frostfs.sdk.examples.ContainerExample;
import info.frostfs.sdk.examples.NetmapExample;
import info.frostfs.sdk.examples.ObjectExample;
import info.frostfs.sdk.examples.PoolExample;
import info.frostfs.sdk.jdo.ClientSettings;
import info.frostfs.sdk.jdo.parameters.CallContext;

import java.util.concurrent.TimeUnit;

public class Main {
    public static void main(String[] args) {
        CallContext callContext = new CallContext(1, TimeUnit.MINUTES);

        //INIT
        ClientSettings clientSettings = new ClientSettings(
                "KwHDAJ66o8FoLBjVbjP2sWBmgBMGjt7Vv4boA7xQrBoAYBE397Aq",
                "http://localhost:8080"
        );
        FrostFSClient frostFSClient = new FrostFSClient(clientSettings);

        //NETMAP
        NetmapExample.testNetmap(frostFSClient, callContext);

        //CONTAINER
        ContainerExample.testContainer(frostFSClient, callContext);

        //OBJECT
        ObjectExample.testObject(frostFSClient, callContext);

        //POOL
        PoolExample.initPool(callContext);
    }
}
