package info.frostfs.sdk.examples;

import info.frostfs.sdk.FrostFSClient;
import info.frostfs.sdk.dto.container.Container;
import info.frostfs.sdk.dto.container.ContainerId;
import info.frostfs.sdk.dto.netmap.PlacementPolicy;
import info.frostfs.sdk.dto.netmap.Replica;
import info.frostfs.sdk.jdo.parameters.CallContext;
import info.frostfs.sdk.jdo.parameters.container.PrmContainerCreate;
import info.frostfs.sdk.jdo.parameters.container.PrmContainerDelete;
import info.frostfs.sdk.jdo.parameters.container.PrmContainerGet;
import info.frostfs.sdk.jdo.parameters.container.PrmContainerGetAll;

import java.util.List;
import java.util.UUID;

public class ContainerExample {

    public static void testContainer(FrostFSClient frostFSClient, CallContext callContext) {
        //LIST
        List<ContainerId> containerIds = frostFSClient.listContainers(new PrmContainerGetAll(), callContext);

        //CREATE
        var placementPolicy = new PlacementPolicy(new Replica[]{new Replica(3)}, true, 1);
        var prmContainerCreate = new PrmContainerCreate(new Container(placementPolicy));

        prmContainerCreate.getContainer().getAttributes().put("с", UUID.randomUUID().toString());

        var containerId = frostFSClient.createContainer(prmContainerCreate, callContext);

        //GET
        var prmContainerGet = new PrmContainerGet(containerId);
        var container = frostFSClient.getContainer(prmContainerGet, callContext);

        //DELETE
        var prmContainerDelete = new PrmContainerDelete(containerId);
        frostFSClient.deleteContainer(prmContainerDelete, callContext);

        List<ContainerId> updateContainerIds2 = frostFSClient.listContainers(new PrmContainerGetAll(), callContext);
    }
}
