package info.frostfs.sdk.examples;

import info.frostfs.sdk.FrostFSClient;
import info.frostfs.sdk.Helper;
import info.frostfs.sdk.jdo.parameters.CallContext;

public class NetmapExample {

    public static void testNetmap(FrostFSClient frostFSClient, CallContext callContext) {
        var netmap = frostFSClient.getNetmapSnapshot(callContext);
        System.out.printf("Epoch: %s%n", netmap.getEpoch());
        System.out.println("Nodes:");
        var i = 0;
        for (var nodeInfo : netmap.getNodeInfoCollection()) {
            System.out.printf("     Node %s:%n", i++);
            System.out.printf("     Version: %s%n", nodeInfo.getVersion());
            System.out.printf("     State: %s%n", nodeInfo.getState());
            System.out.printf("     PublicKey: %s%n", Helper.getHexString(nodeInfo.getPublicKey()));
            System.out.printf("     Address: %s%n", nodeInfo.getAddresses().get(0));
            System.out.println("     Attributes:");

            for (var attr : nodeInfo.getAttributes().entrySet()) {
                System.out.printf("         %s: %s%n", attr.getKey(), attr.getValue());
            }
        }
    }
}
