package info.frostfs.sdk.examples;

import info.frostfs.sdk.dto.container.Container;
import info.frostfs.sdk.dto.netmap.PlacementPolicy;
import info.frostfs.sdk.dto.netmap.Replica;
import info.frostfs.sdk.jdo.ECDsa;
import info.frostfs.sdk.jdo.parameters.CallContext;
import info.frostfs.sdk.jdo.parameters.container.PrmContainerCreate;
import info.frostfs.sdk.jdo.pool.NodeParameters;
import info.frostfs.sdk.jdo.pool.PoolInitParameters;
import info.frostfs.sdk.pool.Pool;

public class PoolExample {

    public static void initPool(CallContext callContext) {
        //Init
        NodeParameters nodeParam1 = new NodeParameters(1, "http://ip1:8080", 1);
        NodeParameters nodeParam2 = new NodeParameters(1, "http://ip2:8080", 1);
        NodeParameters nodeParam3 = new NodeParameters(1, "http://ip3:8080", 1);
        NodeParameters nodeParam4 = new NodeParameters(2, "http://ip4:8080", 1);

        PoolInitParameters initParameters = new PoolInitParameters();
        initParameters.setKey(new ECDsa("L4NzJXAFDXxhBPY6CupwAATpCyhMSoQXyQesyLcJ79eQHnmVmuMh"));
        initParameters.setNodeParams(new NodeParameters[]{nodeParam1, nodeParam2, nodeParam3, nodeParam4});

        Pool pool = new Pool(initParameters);

        //Dial (Required!)
        pool.dial(callContext);

        //Operations
        var netmap = pool.getNetmapSnapshot(callContext);

        var placementPolicy = new PlacementPolicy(new Replica[]{new Replica(3)}, true, 1);
        var prmContainerCreate = new PrmContainerCreate(new Container(placementPolicy));

        var containerId = pool.createContainer(prmContainerCreate, callContext);
        //ETC
    }
}