package info.frostfs.sdk.examples.object;

import info.frostfs.sdk.ArrayHelper;
import info.frostfs.sdk.FrostFSClient;
import info.frostfs.sdk.dto.container.ContainerId;
import info.frostfs.sdk.dto.object.ObjectFrostFS;
import info.frostfs.sdk.dto.object.ObjectId;
import info.frostfs.sdk.jdo.parameters.CallContext;
import info.frostfs.sdk.jdo.parameters.object.PrmObjectGet;
import org.apache.commons.lang3.ArrayUtils;

import static java.util.Objects.isNull;

public class ObjectGet {

    public static void exampleStream(FrostFSClient frostFSClient, ContainerId containerId, ObjectId objectId,
                                     CallContext callContext) {
        var prmObjectGet = new PrmObjectGet(containerId, objectId);
        ObjectFrostFS object = frostFSClient.getObject(prmObjectGet, callContext);

        var reader = object.getObjectReader();
        var chunk = reader.readChunk();
        var length = chunk.length;
        byte[] buffer = null;
        while (length > 0) {
            buffer = isNull(buffer) ? chunk : ArrayHelper.concat(buffer, chunk);

            chunk = object.getObjectReader().readChunk();
            length = ArrayUtils.isEmpty(chunk) ? 0 : chunk.length;
        }
    }
}
