package info.frostfs.sdk.examples.object;

import info.frostfs.sdk.FrostFSClient;
import info.frostfs.sdk.dto.container.ContainerId;
import info.frostfs.sdk.dto.object.ObjectAttribute;
import info.frostfs.sdk.dto.object.ObjectHeader;
import info.frostfs.sdk.dto.object.ObjectId;
import info.frostfs.sdk.enums.ObjectType;
import info.frostfs.sdk.jdo.parameters.CallContext;
import info.frostfs.sdk.jdo.parameters.object.PrmObjectPut;

import java.io.FileInputStream;
import java.io.IOException;

public class ObjectPut {

    public static void exampleStream(FrostFSClient frostFSClient, ContainerId containerId, CallContext callContext) {
        ObjectId oid;
        try (FileInputStream file = new FileInputStream("/home/ori/Desktop/DemoExample/cat.jpg")) {
            var attribute = new ObjectAttribute("Filename", "cat.jpg");
            var cat = new ObjectHeader(containerId, ObjectType.REGULAR, attribute);
            var prmObjectPut = PrmObjectPut.builder().objectHeader(cat).build();
            var writer = frostFSClient.putObject(prmObjectPut, callContext);

            writer.write(file.readAllBytes());
            oid = writer.complete();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
