package info.frostfs.sdk.examples.object;

import info.frostfs.sdk.FrostFSClient;
import info.frostfs.sdk.dto.container.ContainerId;
import info.frostfs.sdk.dto.object.ObjectAttribute;
import info.frostfs.sdk.dto.object.ObjectHeader;
import info.frostfs.sdk.dto.object.ObjectId;
import info.frostfs.sdk.enums.ObjectType;
import info.frostfs.sdk.jdo.parameters.CallContext;
import info.frostfs.sdk.jdo.parameters.object.PrmObjectClientCutPut;

import java.io.FileInputStream;
import java.io.IOException;

public class ObjectPutClientCut {

    public static void exampleStream(FrostFSClient frostFSClient, ContainerId containerId, CallContext callContext) {
        ObjectId oid;
        try (FileInputStream file = new FileInputStream("/home/ori/Desktop/DemoExample/cat.jpg")) {
            var attribute = new ObjectAttribute("Filename", "cat.jpg");
            var cat = new ObjectHeader(containerId, ObjectType.REGULAR, attribute);
            var prmObjectPut = PrmObjectClientCutPut.builder().objectHeader(cat).payload(file).bufferMaxSize(1024).build();
            oid = frostFSClient.putClientCutObject(prmObjectPut, callContext);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
